theory faithful
imports
"OCL"
begin

holocl_params [ocl_syntax=ascii]

section {* HOL-OCL is faithful to the semantics of Appendix A *}



lemma not_faithfully_represented:
  "Sem[[\<MathOclNot> X]] \<gamma>   = (if Sem[[X]] \<gamma>  \<noteq>  \<bottom>  
                     then \<HolOclLiftLeft>\<not> \<HolOclDropLeft> Sem[[X]]\<gamma> \<HolOclDropRight>\<HolOclLiftRight>  
                     else \<bottom>)"
  apply(simp add: OclNot_def DEF_def 
                  lift0_def lift1_def lift2_def
                  semfun_def )
done

lemma and_faithfully_represented:
  "Sem[[X \<MathOclAnd> Y]] \<gamma> =
      (if      Sem[[X]] \<gamma> = \<HolOclLiftLeft>False\<HolOclLiftRight> \<and> Sem[[Y]] \<gamma> = \<HolOclLiftLeft>False\<HolOclLiftRight> then \<HolOclLiftLeft>False\<HolOclLiftRight>
       else if Sem[[X]] \<gamma> = \<HolOclLiftLeft>False\<HolOclLiftRight> \<and> Sem[[Y]] \<gamma> = \<HolOclLiftLeft>True\<HolOclLiftRight>  then \<HolOclLiftLeft>False\<HolOclLiftRight>
       else if Sem[[X]] \<gamma> = \<HolOclLiftLeft>True\<HolOclLiftRight>  \<and> Sem[[Y]] \<gamma> = \<HolOclLiftLeft>False\<HolOclLiftRight> then \<HolOclLiftLeft>False\<HolOclLiftRight>
       else if Sem[[X]] \<gamma> = \<HolOclLiftLeft>True\<HolOclLiftRight>  \<and> Sem[[Y]] \<gamma> = \<HolOclLiftLeft>True\<HolOclLiftRight>  then \<HolOclLiftLeft>True\<HolOclLiftRight>
       else if Sem[[X]] \<gamma> = \<HolOclLiftLeft>False\<HolOclLiftRight> \<and> Sem[[Y]] \<gamma> = \<bottom>      then \<HolOclLiftLeft>False\<HolOclLiftRight>
       else if Sem[[X]] \<gamma> = \<HolOclLiftLeft>True\<HolOclLiftRight>  \<and> Sem[[Y]] \<gamma> = \<bottom>      then \<bottom>
       else if Sem[[X]] \<gamma> = \<bottom>      \<and> Sem[[Y]] \<gamma> = \<HolOclLiftLeft>False\<HolOclLiftRight> then \<HolOclLiftLeft>False\<HolOclLiftRight>
       else if Sem[[X]] \<gamma> = \<bottom>      \<and> Sem[[Y]] \<gamma> = \<HolOclLiftLeft>True\<HolOclLiftRight>  then \<bottom>
       else if Sem[[X]] \<gamma> = \<bottom>      \<and> Sem[[Y]] \<gamma> = \<bottom>      then \<bottom>
       else \<bottom>)"
  apply(simp add:OclAnd_def
              DEF_def o_def strictify_def
              lift0_def lift1_def lift2_def
              semfun_def )

  apply (cases "X \<gamma> = down")
  apply (cases "Y \<gamma> = down")
  apply (simp_all add: not_down_exists_lift )
  apply (auto)
  done

lemma plus_faithfully_represented:
  "Sem[[  (x::('a Integer)) + (y::('a Integer)) ]] \<gamma> 
  = (if (Sem[[x]] \<gamma>   \<noteq> \<bottom>) \<and> (Sem[[y]] \<gamma>   \<noteq> \<bottom>) 
                     then \<HolOclLiftLeft> \<HolOclDropLeft> Sem[[x]]\<gamma> \<HolOclDropRight> +\<HolOclDropLeft> Sem[[y]]\<gamma> \<HolOclDropRight> \<HolOclLiftRight>   
                     else \<bottom> )"
  apply(simp   add: OCL_Integer.plus_def DEF_def
                  lift0_def lift1_def lift2_def
                  semfun_def )

done


section {* HOL-OCL is fulfills the requirements of Chapter 11 *}

lemmas ss_lifting = ss_lifting'

thm Bag_sem_cases_ext

lemma "req_bag_11_7_1-g":
  "\<MathOclIsEmpty> self    = \<MathOclSizeLeft>(self::('a,'b::bot)Bag)\<MathOclSizeRight> \<MathOclStrictEq> 0"
  apply(rule Bag_sem_cases_ext, simp_all)
  apply(auto simp: OCL_Bag.OclSize_def OclMtBag_def OclStrictEq_def
                   Zero_ocl_int_def ss_lifting)
  done

lemma REQ11_7_1_7:
  "\<MathOclValid> \<MathOclIsDefined>(self ->size()) 
   \<Longrightarrow> 
   self ->isEmpty() = (self::('\<tau>,'\<alpha>::bot)Set) ->size() \<MathOclStrictEq> 0"
  apply(rule ext)
  apply (drule_tac \<tau> = "x" in valid_elim)
  apply (frule defSize_implies_finite_Sets) 
  apply (auto simp:  OclIsEmpty_def OclSize_def OclStrictEq_def
                        Zero_ocl_int_def ss_lifting)
done


end