theory overriding 
imports
  OCL_methodology
begin

holocl_params [ocl_syntax=ascii]


import_model "overriding.zargo" "overriding.ocl"


section {* Analyzing our Specification *}
subsection {* Wellformedness Checks *}

check_wfc_taxonomyConsistency 3


subsection {* Liskovs Substition Principle *}
text {*
  In this section, we prove that our model is compliant to Liskov's substitution 
  principle. The corresponding proof obligations are generated by:
*}
generate_po_liskov "pre"

generate_po_liskov "post"


list_po
text {* 
  Moreover, we can inspect (in interactive mode) these proof obligations by 
  executing:
*}
show_po "overriding.OCL_liskov-po_lsk_pre-1"
        "overriding.OCL_liskov-po_lsk_post-1" 

text{*
We start proving the first proof obligation by:
*}
po "overriding.OCL_liskov-po_lsk_pre-1"
--{* i.e., we need to prove @{subgoals [display]}, which can 
     be done quite easily by unfolding the definitions of the preconditions 
     and applying ocl\_auto: *}
apply(simp add: A.m_Integer_Integer.pre1_def 
                A.m_Integer_Integer.pre1.pre_0_def
                C.m_Integer_Integer.pre1_def
                C.m_Integer_Integer.pre1.pre_0_def
                A.m_Integer_Integer.pre1.pre_1_def)
apply(ocl_auto)
-- {* after our successfull proof attempt, we can discharge this proof obligation: *}
discharged 


text{*
  Similarly, but with an slightly more complicated proof script, we can discharge 
  also the second proof obligation:
*}
po "overriding.OCL_liskov-po_lsk_post-1" 
--{* @{subgoals [display]} *}
  apply(simp add: C.m_Integer_Integer.post1_def 
    C.m_Integer_Integer.post1.post_0_def)
  apply(simp add: A.m_Integer_Integer.post1_def
    A.m_Integer_Integer.post1.post_0_def
    A.m_Integer_Integer.post1.post_1_def)
  apply(safe elim!: and_TRUE_E)
  apply (simp add: OclOne_def OclZero_def OCL_Integer.OclLess_def 
    OCL_Integer.One_ocl_int_def OCL_Integer.Zero_ocl_int_def OclIsDefined_def 
    strictify_def OclLocalValid_def o_def lift0_def lift1_def lift2_def 
    OclTrue_def OclUndefined_def DEF_def OclTrue_def)
apply(auto)
discharged

text{* 
  Finally, we check that no unproven proof obligations are left. If we would have missed 
  one or more proof obligations, the following check would fail:
*}     

check_po  

end


